import React from "react";
import { CommonProps, TypeAttributes } from "../@types/common";
export interface ButtonProps extends CommonProps {
    /** The active button */
    active?: boolean;
    /** The primary content of the component */
    children: React.ReactNode;
    /** Size of the button */
    size?: TypeAttributes.Size;
    /** Button show loading indicator */
    loading?: boolean;
    /** The prefix of the component CSS class name */
    classPrefix?: string;
    /** Button appearence */
    appearance?: "default" | "link" | "subtle" | "primary" | "outline";
    /** Button colors */
    color?: "red" | "green" | "yellow" | "orange" | "blue" | "violet" | "cyan";
    /** You can use custom element to this component */
    componentClass?: React.ElementType;
    /** Button unable to intracted with */
    disabled?: boolean;
    /** You can pass href then will render as 'a' element */
    href?: string;
    /** Click action */
    onClick?: (event: React.MouseEvent) => void;
    /** HTML button attribute */
    type?: "submit" | "reset" | "button";
}
declare const Button: React.FC<ButtonProps>;
export default Button;
