var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useCallback } from "react";
import { Anchor } from "..";
import { useClassNames } from "../utils";
import createChainedFunction from "../utils/createChainedFunction";
var DropdownItem = React.forwardRef(function (props, ref) {
    var _a = props.componentClass, Component = _a === void 0 ? Anchor : _a, _b = props.classPrefix, classPrefix = _b === void 0 ? "dropdown-item" : _b, children = props.children, className = props.className, active = props.active, onClick = props.onClick, onSelect = props.onSelect, itemKey = props.itemKey, rest = __rest(props, ["componentClass", "classPrefix", "children", "className", "active", "onClick", "onSelect", "itemKey"]);
    var _c = useClassNames(classPrefix), merge = _c.merge, withClassPrefix = _c.withClassPrefix;
    var classes = merge(className, withClassPrefix({ active: active }));
    var handleClick = useCallback(function (event) {
        onSelect === null || onSelect === void 0 ? void 0 : onSelect(itemKey, event);
    }, [itemKey]);
    return (React.createElement(Component, __assign({ ref: ref, onClick: createChainedFunction(handleClick, onClick), className: classes }, rest), children));
});
DropdownItem.defaultProps = {
    active: false
};
export default DropdownItem;
