import React from "react";
import { CommonProps, TypeAttributes } from "../@types/common";
export interface DropdownMenuProps<T = string> extends CommonProps {
    /** Reset dropdown menu style from existing style */
    reset?: boolean;
    /** Dropdown open */
    open?: boolean;
    /** Dropdown menu placement */
    placement?: TypeAttributes.Placement8;
    /** The selected item option's key*/
    activeKey?: T;
}
declare const DropdownMenu: React.ForwardRefExoticComponent<Pick<DropdownMenuProps<string>, string | number> & React.RefAttributes<unknown>>;
export default DropdownMenu;
