var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from "react";
import { useClassNames } from "../utils";
import FormLabel from "./FormLabel";
import { createComponent } from "../utils";
export var FormGroupField = createComponent({
    name: "FormGroupField",
    as: "div"
});
export var ErrorField = createComponent({
    name: "ErrorField",
    as: "div"
});
var FormGroup = function (props) {
    var _a = props.classPrefix, classPrefix = _a === void 0 ? "form-group" : _a, children = props.children, className = props.className, size = props.size, label = props.label, id = props.id, labelClassName = props.labelClassName, labelStyle = props.labelStyle, inline = props.inline, hasError = props.hasError, errorMessage = props.errorMessage, rest = __rest(props, ["classPrefix", "children", "className", "size", "label", "id", "labelClassName", "labelStyle", "inline", "hasError", "errorMessage"]);
    var _b = useClassNames(classPrefix), merge = _b.merge, withClassPrefix = _b.withClassPrefix;
    var classes = merge(className, withClassPrefix(size, { inline: inline, "has-error": hasError }));
    var getElements = function () {
        var elements = React.Children.map(children, function (child, index) {
            return React.cloneElement(child, __assign({ hasError: hasError ? hasError : false, key: index, id: id }, child === null || child === void 0 ? void 0 : child.props));
        });
        return { elements: elements };
    };
    var elements = getElements().elements;
    var labelProps = {
        className: labelClassName,
        style: labelStyle,
        htmlFor: id
    };
    var labelElement;
    if (label) {
        labelElement = React.createElement(FormLabel, __assign({}, labelProps), label);
    }
    return (React.createElement("div", __assign({ className: classes }, rest),
        labelElement,
        React.createElement(FormGroupField, null,
            elements,
            React.createElement(ErrorField, null, errorMessage))));
};
export default FormGroup;
