var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from "react";
import { createComponent, useClassNames } from "../utils";
/**
 * Main Header Title Component
 * This create component for title of the header
 */
var MainHeaderTitle = createComponent({
    name: "MainHeaderTitle",
    as: "h1"
});
/**
 * Main Header Navigation Row Component.
 * This component use for warpping the navigation on the header
 */
var HeaderNavigationRow = createComponent({
    name: "HeaderNavigationRow",
    as: "div"
});
var MainHeader = function (props) {
    var _a = props.componentClass, Component = _a === void 0 ? "div" : _a, title = props.title, children = props.children, renderTitle = props.renderTitle, _b = props.classPrefix, classPrefix = _b === void 0 ? "main-header" : _b, className = props.className, navigation = props.navigation, rest = __rest(props, ["componentClass", "title", "children", "renderTitle", "classPrefix", "className", "navigation"]);
    var _c = useClassNames(classPrefix), merge = _c.merge, withClassPrefix = _c.withClassPrefix;
    var classes = merge(className, withClassPrefix({ navigation: navigation }));
    var navigationComponent;
    if (navigation) {
        navigationComponent = (React.createElement(HeaderNavigationRow, null, navigation));
    }
    if (renderTitle) {
        return (React.createElement(Component, __assign({ className: classes }, rest),
            renderTitle(children),
            navigationComponent));
    }
    return (React.createElement(Component, __assign({ className: classes }, rest),
        React.createElement(MainHeaderTitle, null, title),
        navigationComponent));
};
export default MainHeader;
