import React from "react";
import { CommonProps } from "../@types/common";
export interface SidebarNavItemProps extends CommonProps {
    /** The main content */
    children?: React.ReactNode;
    /** Use custom element for this component */
    componentClass?: React.ElementType;
    /** The prefix of component CSS class */
    classPrefix?: string;
    /** The specified url */
    href?: string;
    /** The active component */
    active?: boolean;
    /** On Select of the options */
    onSelect?: () => void;
    /** The nav icon before the main content*/
    iconBefore?: React.ReactNode;
    /** The nav icon after the main content */
    iconAfter?: React.ReactNode;
}
declare const SidebarNavItem: (props: SidebarNavItemProps) => JSX.Element;
export default SidebarNavItem;
