import classnames from 'classnames';
import _ from 'lodash';
export var defaultClassPrefix = 'ts-';
export var getClassNamePrefix = function () {
    return defaultClassPrefix;
};
export var setDefaultClassPrefix = function (name) { return "" + getClassNamePrefix() + name; };
export var addPrefix = function (prefix, className) {
    if (!prefix || !className) {
        return '';
    }
    if (_.isArray(className)) {
        return classnames(className.filter(function (name) { return !!name; }).map(function (name) { return prefix + "-" + name; }));
    }
    return prefix + "-" + className;
};
export default _.curry(addPrefix);
