/**
 * This useClassNames use from rsuite
 * see more detail at link below
 * https://github.com/rsuite/rsuite/blob/908e8f43d2cc8a8a3919cf216ae5405be54fd63a/src/utils/useClassNames.ts#L34
 */
export declare type ClassValue = string | number | ClassDictionary | ClassArray | undefined | null | boolean;
export interface ClassArray extends Array<ClassValue> {
}
export interface ClassDictionary {
    [id: string]: any;
}
/**
 * Add a prefix to all classNames.
 *
 * @param str prefix of className
 * @returns { withClassPrefix, merge, prefix }
 *  - withClassPrefix: A function of combining className and adding a prefix to each className.
 *    At the same time, the default `classPrefix` is the first className.
 *  - merge: A merge className function.
 *  - prefix: Add a prefix to className
 *  - rootPrefix
 */
declare function useClassNames(str: string): {
    withClassPrefix: (...classes: ClassValue[]) => string;
    merge: import("classnames/types").ClassNamesExport;
    prefix: (...classes: ClassValue[]) => string;
    rootPrefix: (...classes: ClassValue[]) => string;
};
export default useClassNames;
