"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var Avatar = function Avatar(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "avatar" : _props$classPrefix,
      className = props.className,
      children = props.children,
      src = props.src,
      _props$circle = props.circle,
      circle = _props$circle === void 0 ? false : _props$circle,
      _props$size = props.size,
      size = _props$size === void 0 ? "md" : _props$size,
      style = props.style,
      color = props.color,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "classPrefix", "className", "children", "src", "circle", "size", "style", "color"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix(size, color, {
    circle: circle,
    photo: src
  }));
  var avatarPhotoStyles = (0, _extends2.default)({}, style, {
    backgroundImage: "url(" + src + ")"
  });

  if (src) {
    return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
      className: classes,
      style: avatarPhotoStyles
    }, rest));
  }

  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    className: classes,
    style: style
  }, rest), children);
};

Avatar.defaultProps = {
  size: "md",
  circle: false
};
var _default = Avatar;
exports.default = _default;