"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var Card = function Card(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      children = props.children,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "card" : _props$classPrefix,
      className = props.className,
      _props$border = props.border,
      border = _props$border === void 0 ? true : _props$border,
      _props$shadow = props.shadow,
      shadow = _props$shadow === void 0 ? true : _props$shadow,
      _props$size = props.size,
      size = _props$size === void 0 ? "md" : _props$size,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "children", "classPrefix", "className", "border", "shadow", "size"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix(size, {
    border: border,
    shadow: shadow
  }));
  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({}, rest, {
    className: classes
  }), children);
};

Card.defaultProps = {
  border: true,
  shadow: true,
  size: "md"
};
var _default = Card;
exports.default = _default;