"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _isUndefined2 = _interopRequireDefault(require("lodash/isUndefined"));

var _react = _interopRequireWildcard(require("react"));

var _utils = require("../utils");

var _DropdownMenu = _interopRequireDefault(require("./DropdownMenu"));

var _DropdownToggle = _interopRequireDefault(require("./DropdownToggle"));

var _createChainedFunction = _interopRequireDefault(require("../utils/createChainedFunction"));

var Dropdown = function Dropdown(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "dropdown" : _props$classPrefix,
      children = props.children,
      className = props.className,
      placement = props.placement,
      toggle = props.toggle,
      renderToggle = props.renderToggle,
      onToggle = props.onToggle,
      onClose = props.onClose,
      onOpen = props.onOpen,
      onClick = props.onClick,
      openProp = props.open,
      onSelect = props.onSelect,
      activeKey = props.activeKey,
      menuStyle = props.menuStyle;

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix());

  var _useState = (0, _react.useState)(openProp || false),
      open = _useState[0],
      setOpen = _useState[1];

  var rootRef = /*#__PURE__*/_react.default.createRef();

  var triggerTarget = (0, _react.useRef)();
  var overlayTarget = (0, _react.useRef)();

  var getOpen = function getOpen() {
    if ((0, _isUndefined2.default)(openProp)) {
      return open;
    }

    return openProp;
  };

  var handleToggle = (0, _react.useCallback)(function (isOpen) {
    var nextOpen = (0, _isUndefined2.default)(isOpen) ? !getOpen() : isOpen;
    var fn = nextOpen ? onOpen : onClose;
    fn === null || fn === void 0 ? void 0 : fn();
    setOpen(nextOpen);
    onToggle === null || onToggle === void 0 ? void 0 : onToggle(nextOpen);
  }, [open, setOpen, onOpen, onClose]);
  var handleClick = (0, _react.useCallback)(function (event) {
    event.preventDefault();
    handleToggle();
  }, [handleToggle]);
  var handleSelect = (0, _react.useCallback)(function (itemKey, event) {
    onSelect === null || onSelect === void 0 ? void 0 : onSelect(itemKey, event);
    handleToggle(false);
  }, []);
  (0, _utils.overlayClose)(function () {
    return handleToggle();
  }, {
    triggerTarget: triggerTarget,
    overlayTarget: overlayTarget,
    disabled: !open
  });
  var dropdownToggleProps = {
    onClick: (0, _createChainedFunction.default)(handleClick, onClick)
  };

  var dropdownToggleElement = /*#__PURE__*/_react.default.createElement(_DropdownToggle.default, (0, _extends2.default)({
    ref: triggerTarget,
    renderToggle: renderToggle
  }, dropdownToggleProps), toggle);

  var dropdownMenuProps = {
    open: open,
    placement: placement
  };

  var dropdownMenuElement = /*#__PURE__*/_react.default.createElement(_DropdownMenu.default, (0, _extends2.default)({
    ref: overlayTarget,
    style: menuStyle,
    activeKey: activeKey,
    onSelect: handleSelect
  }, dropdownMenuProps), children);

  return /*#__PURE__*/_react.default.createElement(Component, {
    ref: rootRef,
    className: classes
  }, dropdownToggleElement, dropdownMenuElement);
};

Dropdown.defaultProps = {
  placement: "bottomStart"
};
var _default = Dropdown;
exports.default = _default;