"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = exports.ErrorField = exports.FormGroupField = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var _FormLabel = _interopRequireDefault(require("./FormLabel"));

var FormGroupField = (0, _utils.createComponent)({
  name: "FormGroupField",
  as: "div"
});
exports.FormGroupField = FormGroupField;
var ErrorField = (0, _utils.createComponent)({
  name: "ErrorField",
  as: "div"
});
exports.ErrorField = ErrorField;

var FormGroup = function FormGroup(props) {
  var _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "form-group" : _props$classPrefix,
      children = props.children,
      className = props.className,
      size = props.size,
      label = props.label,
      id = props.id,
      labelClassName = props.labelClassName,
      labelStyle = props.labelStyle,
      inline = props.inline,
      hasError = props.hasError,
      errorMessage = props.errorMessage,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["classPrefix", "children", "className", "size", "label", "id", "labelClassName", "labelStyle", "inline", "hasError", "errorMessage"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix(size, {
    inline: inline,
    "has-error": hasError
  }));

  var getElements = function getElements() {
    var elements = _react.default.Children.map(children, function (child, index) {
      return /*#__PURE__*/_react.default.cloneElement(child, (0, _extends2.default)({
        hasError: hasError ? hasError : false,
        key: index,
        id: id
      }, child === null || child === void 0 ? void 0 : child.props));
    });

    return {
      elements: elements
    };
  };

  var _getElements = getElements(),
      elements = _getElements.elements;

  var labelProps = {
    className: labelClassName,
    style: labelStyle,
    htmlFor: id
  };
  var labelElement;

  if (label) {
    labelElement = /*#__PURE__*/_react.default.createElement(_FormLabel.default, labelProps, label);
  }

  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: classes
  }, rest), labelElement, /*#__PURE__*/_react.default.createElement(FormGroupField, null, elements, /*#__PURE__*/_react.default.createElement(ErrorField, null, errorMessage)));
};

var _default = FormGroup;
exports.default = _default;