"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var _MainHeader = _interopRequireDefault(require("./MainHeader"));

var _HeaderIcon = _interopRequireDefault(require("./HeaderIcon"));

var _HeaderExtra = _interopRequireDefault(require("./HeaderExtra"));

var Header = function Header(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "page-header" : _props$classPrefix,
      className = props.className,
      title = props.title,
      renderTitle = props.renderTitle,
      navigation = props.navigation;

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix({}));
  var mainHeaderProps = {
    title: title,
    navigation: navigation,
    renderTitle: renderTitle
  };
  return /*#__PURE__*/_react.default.createElement(Component, {
    className: classes
  }, /*#__PURE__*/_react.default.createElement(_HeaderIcon.default, null, "Icon Header"), /*#__PURE__*/_react.default.createElement(_MainHeader.default, mainHeaderProps), /*#__PURE__*/_react.default.createElement(_HeaderExtra.default, null, "header extra"));
};

Header.defaultProps = {
  componentClass: "div",
  classPrefix: "page-header"
};
var _default = Header;
exports.default = _default;