"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var InputGroup = function InputGroup(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? "div" : _props$componentClass,
      className = props.className,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "input-group" : _props$classPrefix,
      children = props.children,
      size = props.size,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "className", "classPrefix", "children", "size"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix(size));

  var getChildren = function getChildren() {
    var elements = _react.default.Children.map(children, function (child, _) {
      var _child$type;

      var displayName = child === null || child === void 0 ? void 0 : (_child$type = child.type) === null || _child$type === void 0 ? void 0 : _child$type.displayName;

      if (displayName === "Input") {
        return /*#__PURE__*/_react.default.cloneElement(child, (0, _extends2.default)({
          key: _
        }, child === null || child === void 0 ? void 0 : child.props));
      }

      return child;
    });

    return {
      elements: elements
    };
  };

  var _getChildren = getChildren(),
      elements = _getChildren.elements;

  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    className: classes
  }, rest), elements);
};

var _default = InputGroup;
exports.default = _default;