"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _Page = require("../Page");

var _utils = require("../utils");

var Sidebar = function Sidebar(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? 'aside' : _props$componentClass,
      children = props.children,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? "sidebar" : _props$classPrefix,
      _props$width = props.width,
      width = _props$width === void 0 ? 240 : _props$width,
      className = props.className,
      collapsible = props.collapsible,
      style = props.style,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "children", "classPrefix", "width", "className", "collapsible", "style"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      withClassPrefix = _useClassNames.withClassPrefix,
      merge = _useClassNames.merge;

  var classes = merge(className, withClassPrefix({
    collapse: collapsible
  }));

  var _useContext = (0, _react.useContext)(_Page.PageContext),
      setHasSidebar = _useContext.setHasSidebar; // hook to the Page component that the child has a sidebar.


  (0, _react.useEffect)(function () {
    setHasSidebar === null || setHasSidebar === void 0 ? void 0 : setHasSidebar(true);
  }, [setHasSidebar]);
  var styles = (0, _extends2.default)({
    width: width + "px"
  }, style);
  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    style: styles,
    className: classes
  }, rest), children);
};

Sidebar.defaultProps = {
  width: 240,
  classPrefix: 'sidebar',
  componentClass: 'aside'
};
var _default = Sidebar;
exports.default = _default;