"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _Anchor = _interopRequireDefault(require("../Anchor"));

var _utils = require("../utils");

var SidebarNavItem = function SidebarNavItem(props) {
  var _props$componentClass = props.componentClass,
      Component = _props$componentClass === void 0 ? _Anchor.default : _props$componentClass,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? 'sidebar-nav-item' : _props$classPrefix,
      children = props.children,
      className = props.className,
      active = props.active,
      iconBefore = props.iconBefore,
      iconAfter = props.iconAfter,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["componentClass", "classPrefix", "children", "className", "active", "iconBefore", "iconAfter"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix({
    active: active
  }));

  var iconBeforeChld = iconBefore && /*#__PURE__*/_react.default.createElement("div", {
    className: "icon icon-before"
  }, iconBefore);

  var iconAfterChld = iconAfter && /*#__PURE__*/_react.default.createElement("div", {
    className: "icon icon-after"
  }, iconAfter);

  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    className: classes
  }, rest), iconBeforeChld, children, iconAfterChld);
};

var _default = SidebarNavItem;
exports.default = _default;